summaryrefslogtreecommitdiff
path: root/plugins/cargo
diff options
context:
space:
mode:
Diffstat (limited to 'plugins/cargo')
-rw-r--r--plugins/cargo/README.md10
-rw-r--r--plugins/cargo/cargo.plugin.zsh38
2 files changed, 16 insertions, 32 deletions
diff --git a/plugins/cargo/README.md b/plugins/cargo/README.md
index 31bae4efe..93e69ae7f 100644
--- a/plugins/cargo/README.md
+++ b/plugins/cargo/README.md
@@ -1,11 +1,3 @@
# cargo
-This plugin adds completion for the Rust build tool [`Cargo`](https://github.com/rust-lang/cargo).
-
-To use it, add `cargo` to the plugins array in your zshrc file:
-
-```zsh
-plugins=(... cargo)
-```
-
-Updated on March 3rd, 2019, from [Cargo 0.34.0](https://github.com/rust-lang/cargo/releases/tag/0.34.0).
+**Deprecated: use the [`rust`](https://github.com/ohmyzsh/ohmyzsh/tree/master/plugins/rust) plugin instead.**
diff --git a/plugins/cargo/cargo.plugin.zsh b/plugins/cargo/cargo.plugin.zsh
index 7082d2d55..e4b338207 100644
--- a/plugins/cargo/cargo.plugin.zsh
+++ b/plugins/cargo/cargo.plugin.zsh
@@ -1,23 +1,15 @@
-if (( $+commands[rustup] && $+commands[cargo] )); then
- # remove old generated completion file
- command rm -f "${0:A:h}/_cargo"
-
- # generate new completion file
- ver="$(cargo --version)"
- ver_file="$ZSH_CACHE_DIR/cargo_version"
- comp_file="$ZSH_CACHE_DIR/completions/_cargo"
-
- mkdir -p "${comp_file:h}"
- (( ${fpath[(Ie)${comp_file:h}]} )) || fpath=("${comp_file:h}" $fpath)
-
- if [[ ! -f "$comp_file" || ! -f "$ver_file" || "$ver" != "$(< "$ver_file")" ]]; then
- rustup completions zsh cargo >| "$comp_file"
- echo "$ver" >| "$ver_file"
- fi
-
- declare -A _comps
- autoload -Uz _cargo
- _comps[cargo]=_cargo
-
- unset ver ver_file comp_file
-fi
+print ${(%):-'%F{yellow}The `cargo` plugin is deprecated and has been moved to the `rust` plugin.'}
+print ${(%):-'Please update your .zshrc to use the `%Brust%b` plugin instead.%f'}
+
+# TODO: 2021-12-28: remove this block
+# Handle $0 according to the standard:
+# https://zdharma-continuum.github.io/Zsh-100-Commits-Club/Zsh-Plugin-Standard.html
+0="${${ZERO:-${0:#$ZSH_ARGZERO}}:-${(%):-%N}}"
+0="${${(M)0:#/*}:-$PWD/$0}"
+# Remove old generated completion file
+command rm -f "${0:A:h}/_cargo" "$ZSH_CACHE_DIR/cargo_version"
+
+(( ${fpath[(Ie)$ZSH/plugins/rust]} )) || {
+ fpath=("$ZSH/plugins/rust" $fpath)
+ source "$ZSH/plugins/rust/rust.plugin.zsh"
+}